/*
 * LatentImage.hpp
 *
 *  Created on: 13 dec. 2015
 *      Author: user
 */

#ifndef TEXTDEBLURPAN_LATENTIMAGE_HPP_
#define TEXTDEBLURPAN_LATENTIMAGE_HPP_

#include "BlurredImage.hpp"
#include "ImageParameter.hpp" // Include header of the base class

/**
 * class representing the latent image.
 */
class LatentImage : public ImageParameter
{
private:
	cv::Mat h;
	cv::Mat v;
	cv::Mat u;
	cv::Mat calculateNomin1(cv::Mat& Kfft, cv::Mat& b);
	cv::Mat calculateDenomin2(cv::Size size) throw (std::domain_error);



public:
  LatentImage(void);
  void initialize(gint size[2]) throw (std::domain_error);
  void solveG(gdouble lambdaGrad, gdouble mu, bool applyThreshold=true) throw (std::domain_error);
  void solveU(gdouble lambdaPixel, gdouble beta) throw (std::domain_error);
  cv::Mat gradientG() throw (std::domain_error);
  cv::Mat getH();
  cv::Mat getV();
  cv::Mat getU();

  void calculateLatent(ImageParameter& kernel, BlurredImage& blurred,
      gdouble lambdaPixel, gdouble lambdaGrad) throw (std::domain_error);
  cv::Mat deblurringAdmAniso(cv::Mat blurred, cv::Mat kernel, double lambdaTV) throw (std::domain_error);
  void cropImage(const cv::Size size);
  cv::Mat calculateLaPlacian(ImageParameter kernel, BlurredImage blurred,double lambdaTV,
		  double lambda, double weightRinging) throw (std::domain_error);
  cv::Mat biLateralFilterPan(cv::Mat& img, double sigmaS, double sigma) throw (std::domain_error);
};

#endif /* TEXTDEBLURPAN_LATENTIMAGE_HPP_ */
