/*
 * Observable.cpp
 *
 *  Created on: Mar 23, 2016
 *      Author: tonpoppe
 */

#include "Observable.hpp"

#include <vector>

#include "../textDeblurPanGui/Observer.hpp"

/**
 * Adds the observers to the list with observers stored in the views parameter.
 *
 * @param obs pointer to the observer which needs to be added
 */
void Observable::attach(Observer *obs) {
    views.push_back(obs);

}

/**
 * Calls the update method of all observers stored in the views vector.
 *
 * @param fraction the parameter values passed to the update method.
 */
void Observable::notify(double fraction){
  for (unsigned int i = 0; i < views.size(); i++){
	views[i]->update(fraction);
  }

};

/**
 * Removes the observer from the observers list.
 *
 * @param obs pointer to the observer which needs to be removed
 */
void Observable::detach(Observer *obs){
  for (unsigned int i = 0; i < views.size(); i++){
    if (views[i] == obs){
      views.erase(views.begin() + i);
    }
  }
};
