/*
 * ProgressBarUpdater.hpp
 *
 * @author  T. Poppe
 * @author  E. van Schaijk
 * @version  1.0
 * @since  July, 2016
 *
 */

#ifndef TEXTDEBLURPANGUI_PROGRESSBARUPDATER_HPP_
#define TEXTDEBLURPANGUI_PROGRESSBARUPDATER_HPP_

#include <libgimp/gimp.h>
#include <libgimp/gimpui.h>
#include <glib.h>
#include "Observer.hpp"

/**
 *  This class is responsible for updating the progress bar of both the deblurDialog and the main GIMP progress bar.
 *  It is designed following the observer pattern.
 *  The observable class class the update method for updating the progress bar
 */
class ProgressBarUpdater : public Observer {
  private:
	GtkProgressBar *_progressbar;

  public:
	ProgressBarUpdater(GtkProgressBar *progressbar);
	void update(double fraction);
	~ProgressBarUpdater();
};

#endif /* TEXTDEBLURPANGUI_PROGRESSBARUPDATER_HPP_ */
